
package jworms.game.explosion;

import jworms.game.GameField;
import jworms.openGL.SmallTexture;
import org.lwjgl.opengl.GL;

import java.awt.geom.Point2D;

public class ExplosionDirtyFireball extends ExplosionCloud{
// static
  /** Dirty fireball texture */
  private static SmallTexture texture = null;

  /**
   * Loads textures and sound.
   */
  public static void init(){
    // load images
    try{
      texture = new SmallTexture("images/explosion/dirtyfireball.png", GL.GL_LINEAR);
    } catch(Exception e){
      System.out.println("Error in ExplosionDirtyFireball during loading images.");
      e.printStackTrace();
    }
  }

// non static
  /**
   * Creates an explosion dirty fireball.
   *
   * @param gameField game field
   * @param position position
   * @param motion motion
   */
  public ExplosionDirtyFireball(GameField gameField, Point2D.Float position, Point2D.Float motion){
    super(gameField, position, motion);

    maxLife = 1;
    scaleFactor = 0.7f;
    alphaFactor = .5f;
  }

  /**
   * Returns the texture.
   *
   * @return texture
   */
  public SmallTexture getTexture(){
    return texture;
  }
}
