
package jworms.game.explosion;

import jworms.openGL.SmallTexture;
import jworms.game.WormUI;
import jworms.game.GameField;
import jworms.util.MathUtil;
import org.lwjgl.opengl.GL;

import java.awt.geom.Point2D;
import java.awt.*;

public class FlameExplosionGlow extends FlameExplosionFlame{
// static
  /** Flame textures. */
  private static SmallTexture texture_background = null;
  private static SmallTexture texture_foreground = null;

  /**
   * Loads textures and sound.
   */
  public static void init(){
    // load images
    try{
      texture_background = new SmallTexture("images/fire/glow_background.png", GL.GL_LINEAR);
      texture_foreground = new SmallTexture("images/fire/glow_foreground.png", GL.GL_LINEAR);
    } catch(Exception e){
      System.out.println("Error in FlameExplosionGlow during loading images.");
      e.printStackTrace();
    }
  }

// non static
  /**
   * Creates an explosion glow.
   *
   * @param gameField game field
   * @param position position
   * @param motion motion
   */
  public FlameExplosionGlow(GameField gameField, Point2D.Float position, Point2D.Float motion){
    super(gameField, position, motion);

    maxLife += (Math.random() - 0.5) * 10;
  }

  public void draw(){
    float alpha = MathUtil.inBounds(0, 1 - (lifeSeconds - maxLife + 3)/3, 1);
    float scale = 1.25f * alpha * scaleFactor;

    GL.glColor4f(1.0f, 1.0f, 1.0f, 0.3f * alpha * alphaFactor);
    draw(texture_background, scale);

  }

  public void drawGlow(){
    float alpha = MathUtil.inBounds(0, 1 - (lifeSeconds - maxLife + 3)/3, 1);
    float scale = alpha * scaleFactor;

    GL.glColor4f(1.0f, 1.0f, 1.0f, 0.5f * alpha * alphaFactor);
    draw(texture_foreground, scale);
  }

  private void draw(SmallTexture texture, float scale){
    Point screen = gameField.fieldToScreen((int) position.x, (int) position.y);
    screen.x -= texture.getImage().getWidth() / 2;
    screen.y -= texture.getImage().getHeight() / 2;

    texture.draw(screen.x, screen.y, scale, scale, angle);
  }
}
